


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable Crate [first $::LyrTech::crateList]
    variable Board [first $::LyrTech::boardList]

    variable RData 0
    variable ROffset 0
    variable WData 0
    variable WOffset 0


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Crate
        variable Board
        variable RData
        variable ROffset
        variable WData
        variable WOffset

           InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
           InsertLog "Crate=$Crate; Board=$Board; RData=$RData; ROffset=$ROffset; WData=$WData; WOffset=$WOffset"
           InsertLog "Crates: $::LyrTech::crateList"
           InsertLog "Boards: $::LyrTech::boardList"
   }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable RData
       variable ROffset
       variable WData
       variable WOffset
       variable Crate
       variable Board

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
               set w [lindex $cgidata 1]
               set vl [second [lindex $cgidata 1]]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   CRATE     {set Crate $vl; SelectVHSADCCrate $vl}
                   BOARD     {set Board $vl; SelectVHSADCBoard $vl}
 
                   ROFFSET {set ROffset $vl}
                   READ    {set RData [ReadVHSADCFpgaRegister $Board $ROffset]}

                   WOFFSET {set WOffset $vl}
                   WDATA   {set WData $vl}
                   WRITE   {WriteVHSADCFpgaRegister  $Board $WOffset $WData}

                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}

